<?php



class VC_WDO_Rotating_Words {


    /**
     * Get things started
     */
    function __construct() {

        add_action('init', array($this, 'wdo_animated_words_init'));
        add_shortcode('wdo_rotating_words', array($this, 'wdo_words_rendering'));
        add_action( 'init', array( $this, 'check_if_vc_is_install' ) );
    }

    function wdo_animated_words_init() {
        if (function_exists("vc_map")) {

            //Register "container" content element. It will hold all your inner (child) content elements
            vc_map(array(
                "name" => __("Rotating Words", "wdo-rotating-words"),
                "base" => "wdo_rotating_words",
                "show_settings_on_create" => true,
                "category" => 'by labibahmed',
                'description' => __('Add animated words', 'wdo-rotating-words'),
                "params" => array(
                        array(
                            "type"          => "dropdown",
                            "heading"       => __("Words Animation Effect"),
                            "value" => array(
                                "Flip" => "flip",
                                "Flip Cube" => "flipCube",
                                "Fade" => "fade",
                                "Flip Up" => "flipUp",
                                "Rotate 1 (PRO Version)" => "flipUp",
                                "Typing (PRO Version)" => "flipUp",
                                "Rotate 2 (PRO Version)" => "flipUp",
                                "Loading Bar (PRO Version)" => "flipUp",
                                "Slide (PRO Version)" => "flipUp",
                                "Clip (PRO Version)" => "flipUp",
                                "Zoom (PRO Version)" => "flipUp",
                                "Rotate 3 (PRO Version)" => "flipUp",
                                "Scale (PRO Version)" => "flipUp",
                                "Push (PRO Version)" => "flipUp",
                            ),
                            "param_name"    => "wdo_words_animation",
                            'save_always' => true,
                            "description"   => __('Select Animation effect for words.<a style="color:#428bca;" href="http://demo.webdevocean.com/css3-rotating-words-demo/" target="_blank"> All Animation Effects</a>'), 
                        ),
                        array(
                            "type" => "textarea",
                            "heading" => "Start Sentence",
                            "param_name" => "wdo_start_sentence",
                            "description"   => __("Text which would be displayed before rotating words."),
                        ),
                        array(
                            "type" => "textarea",
                            "heading" => "Rotating Words(seperated by commas)", 
                            "param_name" => "wdo_words",
                            "description"   => __("Enter words seperated by commas.These would change after intervals."),
                        ),

                        array(
                            "type" => "textarea",
                            "heading" => "End Sentence",
                            "param_name" => "wdo_end_sentence",
                            "description"   => __("Text which would be displayed after rotating words."),
                        ),

                        array(
                            "type" => "html",
                            "heading" => "<h3 style='padding: 10px 10px;background: #131416;width: 35%;border-radius: 10px;text-align: center;margin: 10px auto;color: #fff;'>Pro Features</h3>",
                            "param_name" => "pro_feature_heading",
                            "group" => "PRO Features"
                        ),

                        array(
                            "type"          => "textfield",
                            "heading"       => __("Animation Speed <a style='text-decoration:none;color:#0473aa' href='https://webdevocean.com/product/rotating-words-vc-extension/' target='_blank'> (Pro Feature)</a>"),
                            "param_name"    => "wdo_animate_speed",
                            "description"   => __("Select Animation Speed for words in milliseconds."),
                             "group" => "PRO Features"
                        ),

                        array(
                            "type"          => "colorpicker",
                            "heading"       => __("Sentence Color <a style='text-decoration:none;color:#0473aa' href='https://webdevocean.com/product/rotating-words-vc-extension/' target='_blank'> (Pro Feature)</a>"),
                            "param_name"    => "wdo_sentence_color",
                            "description"   => __("Choose color for the sentence.Default #000."),
                             "group" => "PRO Features"
                            
                        ),

                        array(
                            "type"          => "colorpicker",
                            "heading"       => __("Rotating Words Color <a style='text-decoration:none;color:#0473aa' href='https://webdevocean.com/product/rotating-words-vc-extension/' target='_blank'> (Pro Feature)</a>"),
                            "param_name"    => "wdo_words_color",
                            "description"   => __("Choose color for rotating words.Default #000."),
                             "group" => "PRO Features"
                            
                        ),

                        array(
                            "type"          => "textfield",
                            "heading"       => __("Sentence and Words Font Size <a style='text-decoration:none;color:#0473aa' href='https://webdevocean.com/product/rotating-words-vc-extension/' target='_blank'> (Pro Feature)</a>"),
                            "param_name"    => "wdo_sentence_size",
                            "description"   => __("Set font size for words and sentence.Default 45px."),
                             "group" => "PRO Features"
                            
                        ),

                        array(
                            "type" => "html",
                            "heading" => "<h3 style='padding: 15px 20px;background: #2b4b80;width: 50%;border-radius: 10px;text-align: center;margin: 25px auto;'><a style='text-decoration: none;color: #fff;font-size: 16px;' target='_blank' href='https://webdevocean.com/product/rotating-words-vc-extension/' >Get Pro Version in just $8</a></h3>",
                            "param_name" => "pro_feature",
                            "group" => "PRO Features"
                        ),
                ),
            ));


        }
    }

    function wdo_words_rendering($atts, $content = null, $tag) {


        extract(shortcode_atts(array( 
            'wdo_start_sentence' => '',
            'wdo_words' => '',
            'wdo_end_sentence' => '',
            'wdo_words_animation' => '',
        ), $atts)); 
        

        wp_enqueue_script( 'wdo-rotator-js', plugins_url( 'js/jquery.simple-text-rotator.min.js', __FILE__ ),array('jquery'));
        
        wp_enqueue_script( 'wdo-script-js', plugins_url( 'js/script.js', __FILE__ ),array('jquery'));
        wp_enqueue_style( 'wdo-rotating-text-cs', plugins_url( 'js/simpletextrotator.css', __FILE__ ));
        wp_localize_script( 'wdo-script-js', 'words', array(
                            'animation' => $wdo_words_animation,
                            
                        ));
        ob_start(); 
        $rotate_words_arr = explode(",",$wdo_words);
        $totalWords = count($rotate_words_arr);
        $i = 0;
        ?>
     
        <div class="wdo-rotating-columns">    
            <h1 class="text-rotator"><?php echo $wdo_start_sentence; ?>
                <span class="rotate">
                <?php 
                    foreach ($rotate_words_arr as $key => $word) { $i++; ?>
                        <?php echo $word; ?>
                        <?php  if($i != $totalWords) {
                            echo ",";
                          } ?>
                    <?php } ?>
                </span>
                <?php echo $wdo_end_sentence; ?>
             </h1>
        </div>

        <?php

        $output = ob_get_clean();

        return $output;
    }

    function check_if_vc_is_install(){
        if ( ! defined( 'WPB_VC_VERSION' ) ) {
            // Display notice that Visual Compser is required
            add_action('admin_notices', array( $this, 'showVcVersionNotice' ));
            return;
        }           
    }

    function showVcVersionNotice() { 
        $plugin_name = 'Rotating Words For WPBakery Page Builder';
        echo '
        <div class="updated">
          <p>'.sprintf(__('<strong>%s</strong> requires <strong><a href="https://1.envato.market/93O7W" target="_blank">WPBakery Page Builder</a></strong> plugin to be installed and activated on your site.', 'wdo-carousel'), $plugin_name).'</p>
        </div>';
    }


}

?>